#include <amxmodx>
#include <reapi>

#define PLUGIN    "KK Fade"
#define VERSION   "1.0"
#define AUTHOR    "maFFyoZZyk"

#define KILLER_FADE            // NIEBIESKIE podczas zabijania
#define KILLER_HS_FADE        // ZIELONE podczas zabicia HSem
#define KILLED_FADE            // CZERWONE gdy umierszasz HSem

static mScreenFade;
public plugin_init()
{
    register_plugin(PLUGIN, VERSION, AUTHOR);
    
#if defined KILLER_FADE    || defined KILLER_HS_FADE || defined KILLED_FADE
    register_event("DeathMsg","ScreenFade","a", "1>0");
#endif
    if(!mScreenFade) mScreenFade = get_user_msgid("ScreenFade");
}

public ScreenFade()
{
#if defined KILLER_FADE    || defined KILLER_HS_FADE
    new killer = read_data(1);
    new bool:allowKiller = bool:(is_user_connected(killer) && !IsBlind(killer));
#endif   
#if defined KILLED_FADE
    new victim = read_data(2);
    new bool:allowVictim = bool:(is_user_connected(victim) && !IsBlind(victim));
#endif
#if (defined KILLER_FADE || defined KILLER_HS_FADE) && defined KILLED_FADE
    if(killer == victim) return;
#endif
#if defined KILLER_HS_FADE
    new hs = read_data(3);
#endif

#if defined KILLER_FADE    || defined KILLER_HS_FADE
    if(allowKiller)
    {
    #if defined KILLER_HS_FADE
        if(hs)
        {
            message_begin(MSG_ONE, mScreenFade, .player = killer);
            write_short(1<<10)
            write_short(1<<10)
            write_short(0x0000)
            write_byte(0)
            write_byte(200)
            write_byte(0)
            write_byte(75)
            message_end()
        }
    #endif
    #if defined KILLER_FADE   
        if(!hs)
        {
            message_begin(MSG_ONE, mScreenFade, .player = killer);
            write_short(1<<10)
            write_short(1<<10)
            write_short(0x0000)
            write_byte(0)
            write_byte(0)
            write_byte(200)
            write_byte(75)
            message_end()
        }
    #endif
    }
#endif
#if defined KILLED_FADE
    if(allowVictim)
    {
        message_begin(MSG_ONE, mScreenFade, .player = victim);
        write_short(1<<10)
        write_short(1<<10)
        write_short(0x0000)
        write_byte(255)
        write_byte(0)
        write_byte(0)
        write_byte(75)
        message_end()
    }
#endif
}
stock bool:IsBlind(const pPlayer) {
    return bool: ( Float: get_member( pPlayer, m_blindStartTime ) + Float: get_member( pPlayer, m_blindFadeTime ) >= get_gametime( ) )
}